<template>
  <CreateChatSidebar>
    <div class="conversation-list-container">
      <ChatHeader>
        <JText
          tag="h2"
          weight="normal"
          type="title-3"
          color="text"
        >
          {{ $t('app_menu_item_chat') }}
        </JText>

        <div class="chat-header-actions">
          <CreateChatBtn #default="slotProps">
            <JButton
              v-bind="slotProps"
              icon
              type="outlined"
              color="gray"
              size="s"
              :title="$t('menu_creating_chat')"
            >
              <JIcon icon="presentation" />
            </JButton>
          </CreateChatBtn>
        </div>
      </ChatHeader>
      <JKeyboardNavByFocus v-if="getChats.length">
        <JScrollbarContainer>
          <JScrollbarViewport
            :ref="(component) => {
              viewportRef = component?.$el;
            }"
            @scroll="onScroll"
            class="scrollbar-viewport"
          >
            <div
              ref="scrollContentRef"
              :style="{ height: totalContentHeight }"
            >
              <JList :style="{ transform: offsetY }">
                <JMenu
                  open-by-right-click
                  dynamic-position
                  :max-height="false"
                >
                  <template #activator="slotProps">
                    <JKeyboardNavItem #default="a11yProps">
                      <ConversationListItem
                        v-bind="{ ...slotProps, ...a11yProps }"
                        v-for="chat in visibleNodes"
                        :key="chat.id"
                        tag="router-link"
                        :to="{
                          name: 'chat-details',
                          params: { id: chat.getId() },
                        }"
                        :chat="chat"
                        tabindex="-1"
                        :active="chat.getId() === String(route.params.id)"
                        class="conversation-list-item"
                        @click.right="currentChat = chat"
                      />
                    </JKeyboardNavItem>
                  </template>

                  <JList
                    v-if="currentChat"
                    class="conversation-menu-actions"
                  >
                    <JListItem
                      tag="a"
                      :href="pathConfig.chat + '/' + currentChat.getId()"
                      target="_blank"
                      size="m"
                      class="open-new-tab"
                    >
                      <JIcon
                        size="20px"
                        icon="newTab"
                      />
                      <span class="open-new-tab-label">{{ $t('open_new_tab') }}</span>
                    </JListItem>

                    <OpenChatInNewLayer
                      v-slot="chatNewLayerSlotProps"
                      :chat-id="currentChat.getId()"
                    >
                      <JListItem
                        v-bind="chatNewLayerSlotProps"
                        size="m"
                      >
                        <JIcon
                          size="20px"
                          icon="newLayer"
                        />
                        <span class="open-new-tab-label">{{ $t('open_in_new_layer') }}</span>
                      </JListItem>
                    </OpenChatInNewLayer>

                    <template v-if="currentChat.type === ChatTypes.Group">
                      <!-- <RenameChatBtn :chat-id="currentChat.id" /> -->
                      <LeaveGroupBtn
                        :chat="currentChat"
                        :tag="JListItem"
                        size="m"
                      />
                    </template>

                    <template v-if="currentChat.type === ChatTypes.Private">
                      <DeletePrivateChatBtn
                        :chat="currentChat"
                        :tag="JListItem"
                        size="m"
                      />
                    </template>
                  </JList>
                </JMenu>
              </JList>
            </div>
          </JScrollbarViewport>
          <JScrollbarTrack
            hide-track
            hide-thumb
          />
        </JScrollbarContainer>
      </JKeyboardNavByFocus>
      <div
        v-else-if="isFetchChats"
        class="empty-chats-info"
      >
        <JText
          type="text-1"
          color="secondary-title"
          weight="normal"
          class="mb-1"
        >
          The chat list is empty
        </JText>
        <JText
          type="text-2"
          color="third-text"
          weight="normal"
          class="empty-text"
        >
          This is where your chats will appear when you start communicating
          with other users and representatives of organizations.
        </JText>
      </div>
    </div>
  </CreateChatSidebar>
</template>

<script lang="ts" setup>
import { ref, watch, nextTick } from 'vue';
import { useRoute } from 'vue-router';
import {
  JKeyboardNavByFocus,
  JKeyboardNavItem,
  JList,
  JListItem,
  JMenu,
  JIcon,
  JText,
  JButton,
} from '@new-jira-clone/ui/src/components';
import {
  useCustomScrollbar,
  JScrollbarTrack,
  JScrollbarViewport,
  JScrollbarContainer,
} from '@new-jira-clone/ui/src/components/shared/JScrollbar';
import { useVirtualScroll } from '@new-jira-clone/ui/src/components/shared/JVirtualScroll';
import { CreateChatBtn, CreateChatSidebar } from '@/features/create-chat';
import { DeletePrivateChatBtn } from '@/features/delete-private-chat';
import { LeaveGroupBtn } from '@/features/leave-group';
import { OpenChatInNewLayer } from '@/features/open-chat-in-new-layer';
import { useConversationStateService } from '@/entities/Conversation';
import {
  ChatHeader, ChatTypes, IChat, pathConfig,
  useChatStore,
} from '@/shared';
import ConversationListItem from './ConversationListItem.vue';

const route = useRoute();

const { isFetchChats } = useChatStore();
const { getChats } = useConversationStateService();
const { initScrollbar, onViewportScroll } = useCustomScrollbar();

const scrollContentRef = ref<HTMLElement | null>(null);

const LIST_ITEM_HEIGHT = 65;

const {
  offsetY,
  viewportRef,
  handleScroll,
  visibleNodes,
  totalContentHeight,
} = useVirtualScroll(
  getChats,
  LIST_ITEM_HEIGHT,
);

const onScroll = () => {
  handleScroll();
  onViewportScroll();
};

const initScrollbarOnGetChats = async () => {
  await nextTick();

  requestIdleCallback(() => {
    if (viewportRef.value && scrollContentRef.value) {
      initScrollbar(viewportRef.value, scrollContentRef.value);
    }
  });
};

if (getChats.value.length) {
  initScrollbarOnGetChats();
} else {
  const unwatchGetChats = watch(getChats, (newChats) => {
    if (!newChats.length) return;

    unwatchGetChats();
    initScrollbarOnGetChats();
  });
}

const currentChat = ref<IChat | null>(null);
</script>

<style scoped lang="scss">
@use '@tools' as uiTools;

.conversation-list-container {
  display: flex;
  flex-direction: column;
  position: relative;
  width: 100%;
  height: 100%;

  .chat-header-actions {
    display: flex;
    margin-left: auto;
  }

  .conversation-list-item {
    padding: 0;
    width: 100%;
    max-height: 65px;
    overflow: hidden;
  }
}

.chat-menu-icon {
  color: rgb(var(--j-secondary-title-color));
}

.keyboard-nav {
  overflow: auto;
}

.conversation-menu-actions {
  width: 200px;
}

.open-new-tab {
  display: flex;
  align-items: center;
}

.open-new-tab-label {
  margin-left: 10px;
}

.empty-chats-info {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
}

.empty-text {
  padding: 0 20px;
  text-align: center;
}

.scrollbar-viewport {
  max-height: max-content;
}
</style>
